/*  C/C++ DOOR KIT FOR ACROBAT/2  (c) VRB Corporation 1996  */

/*  Start programming your door from the

    void main(int argc, char *argv[]) {

          readdrop();

    }

    You don't have to know nothing about the things that follows
    right after this big comment and function explanation. However
    you must be able to use these functions listed here. If you know
    structured basic or pascal, you can write doors. If you know c,
    you won't have any problem at all. Experiment with it... It isn't
    that difficult, only a bit hard at the beginning :)

    IMPORTANT! TAKE A LOOK AT THE EXAMPLE INCLUDED!!!

    You can use the following functions in your program:

        ALL C/C++ statements from Borland C/C++ for OS/2
        The functions I have included to write easily doors

	   beep;	       generates a sound

               locate(x,y);    same as gotoxy (pascal, C, basic) put
			       cursor at position x,y. x can be from
			       1 to 80 (width screen), y can vary from
			       1 to 24 (screen length)

	   eol; 	       clears line from cursorposition, for example

			       locate(1,5);  // put cursor on location 1,5
			       eol;      // clear everything from column 1

	   setdisplay(a,b,c);  change colours from text you want to print on
				   screen: a,b,c can be the following...
				   0 = default, 1 = high intensity, 4 = underline
				   5=blinking,7=inverse,8=invisible (black-on-black),30=foreground black
				   31=fore red,32=fore green,33=fore yellow,34=fore blue,35=fore magenta,
				   36=fore cyan,37=fore white,40=background black,41=back red,42=back green
				   43=back yellow,44=back blue,45=back magenta,46=back cyan,47=back white.
				   for example: setdisplay(37,40,1); will print in
                                   bright white on a black background

               cls;                clears screen

               carrier();          returns 1 if carrier is still high, other-
                                   wise 0 (connection broken). Normally you
                                   don't need to use this function if you use
                                   waitkey() and input(...). These functions
                                   check always if carrier is still high.

				   for example:

                                         if(!carrier()) {
                                            printf("User disappeared :-(");
					 }


               byteready();        returns true if there's are bytes ready
                                   to receive. Same comment as above, if you
				   use waitkey and input, you don't need to
                                   use this, unless you want to make your own
                                   input routines for special game needs etc
                                   use byteready() with getbyte!!!!

				   for example:

                                       char c;
                                       while(!byteready());

                                       if(byteready()) {
                                            getbyte(&c);
                                       }

               getbyte();         get a byte (unsigned char) from the modem
                                  use this always in conjunction with byte-
                                  ready!

				  see example above

               sendbyte();        send a character to the modem

				  for example:  sendbyte('T');

               sendstring();      send a whole string to the modem (NOT at
                                  local screen)

				  for example:  sendstring("Hello Guyz");


               mprintf();         send a string to the modem AND local screen
                                  YOU NEED TO USE ALMOST 95% OF THE CASES

                                  for example:

                                       locate(25, 10);  // middle of the screen
                                       mprintf("Welcome to AcroBat");

               waitkey();         waits for a character inputted by the user
                                  or sysop. (who will be 1 if the sysop pres-
                                  sed the key, otherwise 0, nice for an ex-
                                  ternal chatter)

                                  for example:


				      char c;
                                      c=waitkey();

	       input();           reads a complete string inputted by the
                                  user

                                  for example: put a question at position(1,5)
                                               'Give name' on the screen in
					       white on black and puts the
                                               answer of the user in contents

                                  char contents[32];
                                  contents[0]=0;
				  input(1, 5, 30, "Give name", contents, 0, 7, 0);



               showtext();        shows a ansi file to the local screen and
                                  user screen

                                  for example:

                                  showtext("C:\DOOR\ANSIS\MENU.ANS");


              readdrop();         this will read automatic an acrobat door
				  drop file so you know who is online, time
				  left, comm handle, real name, level, kbupped
                                  kbdowned

				  for example:  readdrop();

                                  NOTE THIS SHOULD BE THE FIRST FUNCTION
                                  AFTER YOUR MAIN(int argc, ...);

	      All other functions listed below which aren't mentioned here,
              shouldn't be used. I did minimize the available functions to
              keep it simple, however someone who knows much about c coding
              etc can take a look at the source of the bbs and create doors
              in the bbs source or copy functions from that source into this!


              These functions listed here in this comment are sufficient for
              all screen input/outpunt and keyboard/modem input output. How-
              ever if you want to save settings etc, you have to include
              stdio.h and use fopen, etc, fgets, .... You can include any
              Borland C++ library you want (only os/2 version)


	      If you are someone who starts programming a door, I'll always
	      help you on it... Just write me a note via internet:

	      vanrillaer@tornado.be


	      Many of these functions can/could be written better, I don't
	      say my routines are excellent!!! The only thing I can say
	      is that they do the job correctly and without using much
	      resources/cpu time!

	      Make sure you are compiling for AVIO mode (windowed or full-
	      screen text mode program) PM isn't supported.



	      Now something more about the VARIABLES:


	      const slice=25;       this is for giving slices to other applications
				    25 is a very good nice value. Don't change this,
				    unless you are a specialist

	      HFILE comhandle;      Never change this value!?! If you do so, com-
				    munication with the modem won't work anymore!

	      int who=0;            used by waitkey! If who=1 the char returned was
				    inputted by the sysop. if who=0 the character was
				    inputted by the user on the remote end

	      int local=1;          don't change this variable, is automatic set by
				    readdrop(), local=1 means local and local=0 means
				    that there a remote user in the door. If local is
				    1 the door is run locally.

	      char lijn[260]="";    Never use lijn as variable! It's also a global
				    variable that is used for screen handling.


	      All these variables are automatic setted by readdrop

	      char alias[40]="";    This contains the alias (auto set by readdrop())
	      char name[40]="";     This contains the real name (auto set by readdrop())
	      long kbup=0;          This contains the kb upped by the user until now.
	      long kbdown=0;        Kb downed by user until now.
	      int timeleft=0;       Time the user has left in minutes
	      int level=0;          Level of the user.

*/

#define INCL_BASE
#define INCL_DOSDEVICES
#define INCL_DOSDEVIOCTL

#define beep              sprintf(lijn,"\007");mprintf(lijn)
#define locate(x,y)	  sprintf(lijn,"\x1b[%c%c;%c%cH",((y)/10+'0'),((y)%10+'0'),((x)/10+'0'),((x)%10+'0'));mprintf(lijn)
#define eol		  sprintf(lijn,"\033[K");mprintf(lijn)
#define setdisplay(a,b,c) sprintf(lijn,"\033[%u;%u;%um",a,b,c);mprintf(lijn)
#define cls		  setdisplay(37,40,1); sprintf(lijn,"\033[2J");mprintf(lijn)

#include <os2.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <share.h>
#include <dos.h>
#include <time.h>


const true=1, false=0;
const slice=25;

HFILE comhandle;

int who=0;
int local=1;
char lijn[260]="";

char alias[40]="";
char name[40]="";
long kbup=0;
long kbdown=0;
int timeleft=0;
int level=0;

void DosDevError(APIRET rc) {

     switch(rc) {
	    case 1  : clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_INVALID_FUNCTION"); exit(255);
	    case 6  : clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_INVALID_HANDLE"); exit(255);
	    case 15 : clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_INVALID_DRIVE"); exit(255);
	    case 31 : clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_GEN_FAILURE"); exit(255);
	    case 87 : clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_INVALID_PARAMETER"); exit(255);
            case 111: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_BUFFER_OVERFLOW"); exit(255);
            case 115: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_PROTECTION_VIOLATION"); exit(255);
            case 117: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_INVALID_CATEGORY"); exit(255);
            case 119: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_BAD_DRIVER_LEVEL"); exit(255);
            case 163: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_UNCERTAIN_MEDIA"); exit(255);
	    case 165: clrscr(); printf("ERROR DOSDEVIOCTL: ERROR_MONITORS_NOT_SUPPORTED"); exit(255);
    }

}


void SIOError(USHORT err) {

   if(err & 1)  clrscr(); printf("A buffer overrun has occurred."); exit(255);
   if(err & 3)  clrscr(); printf("An overrun occurred at the UART."); exit(255);
   if(err & 7)  clrscr(); printf("The UART detected a parity error."); exit(255);
   if(err & 15) clrscr(); printf("The UART detected a framing error."); exit(255);

}

void setbreakoff(void) {

   USHORT err;
   APIRET rc;
   ULONG length;

   length=sizeof(err);
   rc=DosDevIOCtl(comhandle, IOCTL_ASYNC, ASYNC_SETBREAKOFF, NULL, 0, NULL, &err, sizeof(err), &length);
   if(rc!=0) DosDevError(rc);
   if(err!=0) SIOError(err);

}

void setbreakon(void) {

   APIRET rc;
   USHORT err;
   ULONG length;

   length=sizeof(err);
   rc=DosDevIOCtl(comhandle, IOCTL_ASYNC, ASYNC_SETBREAKON, NULL, 0, NULL, &err, sizeof(err), &length);
   if(rc!=0) DosDevError(rc);
   if(err!=0) SIOError(err);

}


BYTE modin(void) {

  APIRET rc;
  ULONG length;
  BYTE datapacket;

  length=sizeof(datapacket);
  rc=DosDevIOCtl(comhandle, IOCTL_ASYNC, ASYNC_GETMODEMINPUT, NULL, 0, NULL, &datapacket, sizeof(datapacket), &length);
  if(rc!=0) DosDevError(rc);
  return(datapacket);

}

int carrier(void) {

  return((modin() & 128) ? true : false);

}

USHORT charsininputbuffer(void) {

   APIRET rc;
   ULONG length;
   struct {
      USHORT bytesbuffered;
      USHORT sizebuffer;
   } datapacket;

   length=sizeof(datapacket);
   rc=DosDevIOCtl(comhandle, IOCTL_ASYNC, ASYNC_GETINQUECOUNT, NULL, 0, NULL, &datapacket, sizeof(datapacket), &length);
   if(rc!=0) DosDevError(rc);
   return(datapacket.bytesbuffered);

}

int byteready(void) {
  int temp;

  temp=charsininputbuffer();
  if(temp>0) return(true);
  return(false);

}

char getbyte(char * teken) {

  APIRET rc;
  ULONG bytesread;

  rc=DosRead(comhandle, (PVOID) teken, 1L, &bytesread);
  if(rc!=0) {
    switch(rc) {
      case 5:   clrscr(); printf("DOSREAD ERROR: ERROR_ACCESS_DENIED"); exit(255);
      case 6:   clrscr(); printf("DOSREAD ERROR: ERROR_INVALID_HANDLE"); exit(255);
      case 26:  clrscr(); printf("DOSREAD ERROR: ERROR_NOT_DOS_DISK"); exit(255);
      case 33:  clrscr(); printf("DOSREAD ERROR: ERROR_LOCK_VIOLATION"); exit(255);
      case 109: clrscr(); printf("DOSREAD ERROR: ERROR_BROKEN_PIPE"); exit(255);
      case 234: clrscr(); printf("DOSREAD ERROR: ERROR_MORE_DATA"); exit(255);
    }
  }
  if(bytesread>0) return(true);
  return(false);

}

char sendbyte(char teken) {

  APIRET rc;
  ULONG bytewritten;
  char dummy[2];

  dummy[0]=teken;
  dummy[1]=0;
  rc=DosWrite(comhandle, (PVOID) dummy, 1L, &bytewritten);
  if(rc!=0) {
      switch(rc) {
       case 5:   clrscr(); printf("DOSWRITE ERROR: ERROR_ACCESS_DENIED"); exit(255);
       case 6:   clrscr(); printf("DOSWRITE ERROR: ERROR_INVALID_HANDLE"); exit(255);
       case 19:  clrscr(); printf("DOSWRITE ERROR: ERROR_WRITE_PROTECT"); exit(255);
       case 26:  clrscr(); printf("DOSWRITE ERROR: ERROR_NOT_DOS_DISK"); exit(255);
       case 29:  clrscr(); printf("DOSWRITE ERROR: ERROR_WRITE_FAULT"); exit(255);
       case 33:  clrscr(); printf("DOSWRITE ERROR: ERROR_LOCK_VIOLATION"); exit(255);
       case 109: clrscr(); printf("DOSWRITE ERROR: ERROR_BROKEN_PIPE"); exit(255);
      }
   }
   if(bytewritten==1) {
     return(true);
   } else {
     return(false);
   }

}


int sendstring(char * tekst) {

   ULONG written;
   APIRET rc;
   int i;

   for(i=0; i<strlen(tekst); i++) {
     rc=DosWrite(comhandle, (PVOID) (tekst+i), 1L, &written);
     if(rc!=0) {
       switch(rc) {
               case 5:   clrscr(); printf("DOSWRITE ERROR: ERROR_ACCESS_DENIED"); exit(255);
               case 6:   clrscr(); printf("DOSWRITE ERROR: ERROR_INVALID_HANDLE"); exit(255);
               case 19:  clrscr(); printf("DOSWRITE ERROR: ERROR_WRITE_PROTECT"); exit(255);
               case 26:  clrscr(); printf("DOSWRITE ERROR: ERROR_NOT_DOS_DISK"); exit(255);
               case 29:  clrscr(); printf("DOSWRITE ERROR: ERROR_WRITE_FAULT"); exit(255);
               case 33:  clrscr(); printf("DOSWRITE ERROR: ERROR_LOCK_VIOLATION"); exit(255);
               case 109: clrscr(); printf("DOSWRITE ERROR: ERROR_BROKEN_PIPE"); exit(255);
	}
     }
     if(written!=1) return(i);
   }
   return(strlen(tekst));

}

void cl(void) {

     textcolor(7);
     textbackground(0);
     clrscr();
     printf("CARRIER LOST");
     exit(1);

}

void mprintf(char * tekst) {

   int written=0;
   int i;

   if(local==0) {

      if(!carrier()) {
         cl();
      }
      written=sendstring(tekst);

      if(written!=strlen(tekst)) {

         for(i=written+1;i<strlen(tekst);i++) {
	   while(sendbyte(tekst[i])==false);
	 }

      }

   }
   printf(tekst);

}

int waitkey(void) {

  char c;
  char msg[257];

  while(1) {
    if(kbhit()) {
	who=1;
	c=getch();
        if(c==0) {
	  c=getch();
	  return(c+500);
       }       return(c);
    }
    if(local==0) {

      if(!carrier()) {
	 cl();
      }
      if(byteready()) {

	who=0;
	getbyte(&c);

	if(c=='\033') {

		while(!byteready()) {
		       if(!carrier()) {
			     cl();
		       }
		}

		if(byteready()) {

		    getbyte(&c);

		    if(c=='[') {
			  while(!byteready()) {

				 if(!carrier()) {
				     cl();
				 }

			  }
			  if(byteready()) {

				getbyte(&c);
				if(c=='D') return(575);
				if(c=='C') return(577);
				if(c=='A') return(572);
				if(c=='B') return(580);
				return(0);

			  }
		    }
		    return(0);
		}

	}
	return(c);
      }
    }
    DosSleep(slice);
  }
}


void string(char *t, int n, char teken) {

    int i;

    for(i=0;i<n;i++)  {
	 t[i]=teken;
    }
    t[i]='\0';

}

void rechthoek(int x1, int y1,int x2,int y2, int c1,int c2, int type) {

 int i,j;
 char hulp[80];
 char hulp2[80];

 string(hulp,x2-x1-1,' ');
 setdisplay(30+c1,40+c2,1);
 if(type==0) {
	   locate(x1,y1);
	   mprintf(hulp);
 } else  {
	   locate(x1,y1);
	   mprintf("");
	   string(hulp2,x2-x1-1,'');
	   mprintf(hulp2);
	   mprintf("");
	   for(i=y1+1;i<y2;i++)  {
		    locate(x1,i);
		    mprintf("");
		    mprintf(hulp);
		    locate(x2,i);
		    mprintf("");
	   }
	   locate(x1,y2);
	   mprintf("");
	   mprintf(hulp2);
	   mprintf("");
 }

}

int input(int x, int y, int lengte, char *prompt, char *in, int toets, int c1, int c2) {

 char buf[257];
 char msg[257];
 char page2[4096]="";
 char zin[250]="";
 char res[80]="";
 char set[80]="";
 int begin;
 int einde;
 int keuze=0;
 int insert=0;
 int start;
 int i,j,k;

 if(toets==0) strcpy(set,"ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789#&|@/\\()!{}-+*$%=:;.'?<>_");
 if(toets==1) strcpy(set,"ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789!@#$%^&()_-~{}'`./\\");
 if(toets==2) strcpy(set,"0123456789:/-");
 if(toets==3) strcpy(set,"YN");
 if(toets==4) strcpy(set,"ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789!@#$%^&()_-~{}'`.*?");

 gettext(1,y,80,y+2,page2);
 locate(x+1,y+1);
 mprintf(prompt);
 begin=x+2+strlen(prompt);
 einde=begin+lengte-1;
 rechthoek(begin,y+1,einde+2,0,c1,c2,0);
 locate(begin,y+1);
 strncpy(zin,in,lengte);
 strupr(zin);
 mprintf(zin);
 _setcursortype(_NORMALCURSOR);
 locate(begin,y+1);
 start=begin;

 while(keuze!=13 && keuze!=27) {

  keuze=waitkey();

  switch(keuze) {
           case 633:
           case 634:
	   case 559:
           case 560:
           case 561:
           case 562:
           case 563:
           case 564:
           case 565:
           case 566:
           case 567:
           case 568:
           case 580:
           case 572:
           case 573:
           case 581: {
		     break;
           }
           case 8: {
                      if(start-begin>0)  {
                               _setcursortype(_NOCURSOR);
                               gettext(begin,y+1,einde,y+1,zin);
			       string(res,lengte+1,' ');
                               j=0;
                               k=0;
                               for(i=0;i<=strlen(zin);i++) {

                                    if(i%2==0)  {

				       if(j!=start-begin-1)   {
                                                res[k]=(int)zin[i];
                                                k++;
                                       }

                                       j++;

                                    }

                               }
                               res[k-1]=' ';
                               res[k]=0;
                               locate(begin,y+1);
                               mprintf(res);
			       if(insert==0) _setcursortype(_NORMALCURSOR); else _setcursortype(_SOLIDCURSOR);
                               start-=1;
                               locate(start,y+1);
                      }
                      break;
           }
           case 577: {

                     start+=1;
                     if(start>einde) start=einde;
                     locate(start,y+1);
                     break;

	   }
           case 575: {

                     start-=1;
                     if(start<begin) start=begin;
                     locate(start,y+1);
                     break;

           }
           case 571: {

                     start=begin;
                     locate(start,y+1);
                     break;

           }
           case 579: {

                     gettext(begin,y+1,einde,y+1,zin);
		     string(res,lengte+1,' ');
                     j=0;

                     for(i=0;i<=strlen(zin);i++) {
                              if(i%2==0) {
                                       res[j]=(int)zin[i];
                                       j++;
                              }
		     }

                     res[j]=0;
                     i=strlen(res);
                     k=-1;
		     while(i>=0) {

                          if(res[i]!=32 && res[i]!=0) {
                               k=i;
                               i=-1;
                          }
                          i--;

                     }
		     start=begin+k+1;
		     if(start>einde) start=einde;
                     locate(start,y+1);
                     break;

           }
           case 582: {
                     if(insert==0) {
                           insert=1;
                          _setcursortype(_SOLIDCURSOR);
                     } else {
                           insert=0;
                           _setcursortype(_NORMALCURSOR);
		     }
                     break;

           }
           case 583: {

                     _setcursortype(_NOCURSOR);
                     gettext(begin,y+1,einde,y+1,zin);
		     string(res,lengte+1,' ');
                     j=0;
                     k=0;

                     for(i=0;i<=strlen(zin);i++) {
                        if(i%2==0) {
			    if(j!=start-begin) {
				    res[k]=(int)zin[i];
                                    k++;
                            }
                            j++;
                        }
                     }

                     res[k-1]=' ';
                     res[k]=0;
                     locate(begin,y+1);
                     mprintf(res);
                     if(insert==0) _setcursortype(_NORMALCURSOR); else _setcursortype(_SOLIDCURSOR);
		     locate(start,y+1);
                     break;

           }
           default: {
		    zin[0]=keuze;
                    zin[1]=0;
                    strupr(zin);
                    if(strstr(set,zin)!=NULL) {
                        if(insert==0)  {
                               mprintf(zin);
                               start+=1;
                               if(start>einde) start=einde;
                               locate(start,y+1);
			} else {
			    _setcursortype(_NOCURSOR);
                            gettext(begin,y+1,einde,y+1,zin);
			    string(res,lengte+1,' ');
                            j=0;
                            k=0;
                            for(i=0;i<=strlen(zin);i++) {

                                if(i%2==0) {
                                        if(j>=start-begin) {
                                                res[k]=(int)zin[i];
                                                k++;
                                        }
					j++;
                                }

                            }

			    res[k-2]=0;
                            locate(start,y+1);
                            zin[0]=keuze;
                            zin[1]=0;
                            strupr(zin);
                            mprintf(zin);
                            locate(start+1,y+1);
                            mprintf(res);
                            _setcursortype(_SOLIDCURSOR);
			    start+=1;
			    if(start>einde) start=einde;
                            locate(start,y+1);
                        }
                    }

           }
  }

 }

 gettext(begin,y+1,einde,y+1,zin);
 string(res,lengte+1,' ');
 j=0;
 for(i=0;i<=strlen(zin);i++) {
         if(i%2==0) {
                   res[j]=(int)zin[i];
                   j++;
	 }
 }
 _setcursortype(_NOCURSOR);
 res[j]=0;
 puttext(1,y,80,y+2,page2);
 _setcursortype(_NOCURSOR);
 k=0;
 i=strlen(res);
 while(i>=0) {
	if(res[i]!=32 && res[i]!=0) {
		   k=i+1;
		   i=-1;
	}
	i--;
 }
 strncpy(in,res,k);
 in[k]=0;
 setdisplay(7,0,1);
 if(keuze==27) {
	   return(-1);
 } else {
	   return(0);
 }

}

void showtext(char *s) {

     FILE *tekst;
     char name[257];
     char buf[260];
     char note[357];

     strcpy(name,s);

     tekst=_fsopen(name,"rb",SH_DENYNONE);

     if(tekst==NULL) {
	fclose(tekst);
	    clrscr();
	    printf("ANSI file %s not found!!!",name);
	    exit(255);
     }

     while(!feof(tekst)) {

	    fgets(buf,40,tekst);
	mprintf(buf);

     }
     fclose(tekst);

}


void readdrop(char *path) {
     char buf[257];
     FILE *drop;
     drop=_fsopen(path,"rt",SH_DENYWR);

     fgets(buf,257,drop);
     comhandle=atoi(buf);

     fgets(buf,257,drop);
     local=atoi(buf);

     fgets(alias,257,drop);
     alias[strlen(alias)-1]=0;

     fgets(name,257,drop);
     name[strlen(name)-1]=0;

     fgets(buf,257,drop);
     timeleft=atoi(buf);

     fgets(buf,257,drop);
     kbup=atol(buf);
     fgets(buf,257,drop);
     kbdown=atol(buf);
     fgets(buf,257,drop);
     level=atoi(buf);

     fclose(drop);
}


/* Your door functions/routines start here */

void clear(void) {

     int i=0;

     for(i=7;i<25;i++) {
	locate(1,i);
	eol;
     }

}

void integergame(void) {

	int MIN=10000;
	int MAX=0;
	int LIMIT=0;
	int start, next, sum, reply, try;
	char msg[257];
	char inv[5];
	int ehe=0;

	do {
	   randomize();
	   MAX=random(25000)+MIN;
	} while (MAX % 2 !=0);
	LIMIT=MAX/2;

	setdisplay(37,40,1);
	cls;
	setdisplay(37,44,1);

	locate(32,2);
	mprintf("NORASAURUS, INC.");
	locate(35,4);
	mprintf("presents");
	locate(21, 6);
	mprintf("The Amazing Consecutive Integer Game");

	setdisplay(37,40,1);
	clear();
	locate(1,9);
	mprintf(" Can you find a series of consecutive integers that ");
	sprintf(msg,"add up to %d",MAX);
	mprintf(msg);
	try = 1;
	reply = 1;
	while (1) {

	  inv[0]=0;
	  sprintf(msg,"%s, What is the first integer in this series?",name);
	  input (1,23,5,msg,inv,2,7,0);
	  start=atoi(inv);

	  sum = start;
	  next = start;
	    while (sum < MAX) {
	      ++next;
	      sum = sum + next;
	    }
	   if (sum == MAX) {
		clear();
		locate(1,13);
		mprintf (" CONGRATULATIONS!");
		locate(1,14);
		mprintf (" You have picked the correct starting integer.");
		sprintf (msg, " The integers %d through %d add up to %d.", start, next, sum);
		locate(1,15);
		mprintf(msg);
		locate(1,16);
		sprintf(msg," Attempts needed: %d", try);
		mprintf(msg);
	    }
	   else {
		clear();
		locate(1,13);
		mprintf (" SORRY.\n\r");
		sprintf (msg," The integers %d through %d do not add up to %d.", start, next, MAX);
		locate(1,14);
		mprintf(msg);
		locate(1,15);
		sprintf (msg," They total %d.", sum);
		mprintf(msg);
		locate(1,16);
		sprintf(msg," Attempts: %d", try);
		mprintf(msg);	   }
	  locate(1,19);
	  mprintf (" Would you like to play again?");
	  locate(1,20);
	  mprintf (" 1. Play again.     2. Quit.    3. Quit, but give me the answer.");

	  inv[0]=0;
	  input (1,23,5,"What would you like to do?",inv,2,7,0);
	  reply=atoi(inv);
	  if (reply == 2) {
	    try = 1;
	    break;
	  }
	  if (reply == 3) {
		clear();
		locate(1,10);
		try = 1;
		ehe=0;
		for (start = 1; start < LIMIT; ++start) {
			next = start;
			sum = next;
			while (sum < MAX) {
				++next;
				sum = sum + next;
			}
			if (sum == MAX) {
				ehe++;
				sprintf (msg," The consecutive integers %d through %d total %d\n\r", start, next,sum);
				mprintf(msg);
			}
	      }
	      mprintf("\n\r");
	      sprintf(msg," There are %d solutions for this problem!?! :)\n\r", ehe);
	      mprintf(msg);
	      mprintf("\n\r");
	      mprintf(" Press any key to quit...");
	      waitkey();
	      break;
	}
	++try;
	if(try>36000) {
	      break;
	}

 }
 cls;
 mprintf ("Thanks for playing the Amazing Consecutive Integer Game,\n\r");
 mprintf ("Dennis E. Henley\n\r");
 mprintf ("5106 N. Mango Avenue\n\r");
 mprintf ("Chicago, Illinois 60630\n\r\n\r");
 mprintf ("Thanks. And watch for the next program from Norasaurus, Inc.\n\r\n\r\n\r"); mprintf ("Press any key to return...");
 waitkey();
 setdisplay(37,40,1);
 cls;
 mprintf("Closing door...");}                      \

void main(int argc, char *argv[]) {

	if(argc!=2) {
	    clrscr();
	    printf("Door badly configged in AcroBat/2 CFG\n\n");
	    sleep(2);
	    exit(255);
	}

	readdrop(argv[1]);
	integergame();
	exit(0);
}
